# -----------------------------------------------------------------------------
# $Id: LinedINETSocket.pm 780 2005-02-24 15:02:10Z topia $
# -----------------------------------------------------------------------------
# Lined IO Socket
# -----------------------------------------------------------------------------
# copyright (C) 2003-2004 Topia <topia@clovery.jp>. all rights reserved.
# this module based IrcIO.pm, thanks phonohawk!
package LinedINETSocket;
use strict;
use warnings;
use IO::Socket::INET;
use Tiarra::Utils;
use Tiarra::Socket::Lined;
use base qw(Tiarra::Socket::Lined);

use SelfLoader;
SelfLoader->load_stubs;
1;
__DATA__

# ñ̤ϤԤINET-tcpåȤǤ
# read, writeRunLoopˤäƼưŪ˹Ԥ¾
# pop_queueμ¹flushˤäƤ¹Ԥޤ

# neweolꤹ뤳Ȥˤäơ
# CRLF,LF,CR,ޤNULLʤɡޤޤʹԽüʸѤǤޤ
# άCRLFѤޤ
# callback ꤹ disconnect  callback method ƤФޤ
# $callback->($genre, $errno), $genre  read, write, exception, eof, ⤷
# undef ǡ eof  undef λˤ errno Ϥޤ

sub new {
    my ($class, $eol, $callback) = @_;

    my $this = $class->SUPER::new(
	_caller => 1,
	_subject => 'lined-inet-socket',
	eol => $eol,
       );
    $this->{disconnect_callback} = $callback
	if defined ref($callback) &&
	    ref($callback) eq 'CODE';
    $this;
}

sub disconnect {
    my ($this, $errno, $genre, @params) = @_;
    $this->SUPER::disconnect($errno, $genre, @params);
    if (defined $this->{disconnect_callback}) {
	$this->{disconnect_callback}->($errno, $genre);
    }
}

sub connect {
    # ³ۥȤȥݡȤꤷ³Ԥʤ
    my ($this, $host, $port) = @_;
    return if $this->connected;

    # åȤ򳫤ʤäundef
    my $sock = new IO::Socket::INET(PeerAddr => $host,
				    PeerPort => $port,
				    Proto => 'tcp',
				    Timeout => 5);
    $this->attach($sock);
}

sub attach {
    my $this = shift;
    $this->SUPER::attach(@_);
    $this->install;
}

sub length { shift->write_length; }

sub send_reserve {
    my ($this, $string) = @_;
    # ʸ褦ͽ󤹤롣åȤνäƤʤƤ֥åʤ
    # CRLFϤĤƤϤʤʤ

    if ($this->sock) {
	$this->append_line($string);
    } else {
	die "LinedINETSocket::send_reserve : socket is not connected.";
    }
}

1;
