# -----------------------------------------------------------------------------
# $Id: PatchworkMessage.pm 849 2005-03-21 16:54:09Z topia $
# -----------------------------------------------------------------------------
# copyright (C) 2004 Topia <topia@clovery.jp>. all rights reserved.
package Client::PatchworkMessage;
use strict;
use warnings;
use base qw(Module);
use Mask;
use Multicast;
use NumericReply;
use Module::Use qw(Client::Guess);
use Client::Guess;
use Tiarra::Utils;

sub message_io_hook {
    my ($this,$msg,$io,$type) = @_;

    my $mark_as_need_colon = sub {
	$msg->remark('always-use-colon-on-last-param', 1);
    };

    if ($io->isa('IrcIO::Client')) {
	if ($this->is_target('woolchat', $io)) {
	    if ($type eq 'out' &&
		    $msg->command eq 'NICK') {
		$mark_as_need_colon->();
	    }
	} elsif ($this->is_target('xchat', $io)) {
	    if ($type eq 'out' &&
		    $msg->command eq RPL_WHOISUSER) {
		$mark_as_need_colon->();
	    }
	}
    }
    return $msg;
}

sub is_target {
    my ($this, $target, $io, $default_disable) = @_;

    if (Client::Guess->shared->is_target($target, $io) &&
	    utils->cond_yesno($this->config->get("enable-$target"),
			      !$default_disable)) {
	return 1;
    }
    return 0;
}

1;
=pod
info: IRC åˤäѹäơ饤ȤΥХ
default: off

# äս񤭤ʤϥǥեȤͭǤ
# ޤ Client::GetVersion ƱƤǤ
# Ȥꤢ obsolete ǤΥ⥸塼ǼƤǽ
# Client::Conservative ˤäƼ¸Ǥޤ
# Client::Conservative ǼƤϤʤ褦ʤΤäΤ
# Υ⥸塼н褷ޤ

# WoolChat:
#  бƤå:
#   NICK(ɬ)
#  :
#   NICK ³ľˤȯԤ뤿ᡢ Client::GetVersion ǤȽ̤ޤ
#   ԤƤޤ󡣳饤ȤΥץ client-type  woolchat 
#   ꤷƤ̾ $client-type=woolchat$ Ƚ񤱤 OK Ǥ
enable-woolchat: 1

# X-Chat:
#  бƤå:
#   RPL_WHOISUSER(ɬ)
#  :
#   WHOIS  realname ˥ڡäƤʤȺǽΰʸޤ
enable-xchat: 1

=cut
